#!/bin/bash
#-----BEGIN PGP SIGNATURE-----
#Version: GnuPG v1.2.6 (GNU/Linux)
#Comment: 2008-11-24 ePages Software GmbH (release key) <rnd@epages.de>
#
#iD8DBQBSX7Pql5jMabHSgyARAvtvAKCYgtD8w4uotXIME4kK/QWHQG2NCgCdELSU
#+8VXDJvLCrAK31CzSYnjt0Q=
#=e9/6
#-----END PGP SIGNATURE-----
BN=`basename $0`

usage() {
  echo "Usage: $BN [-t] -f 'FILES' -m TIME[dm] DIR1 DIR2 DIR3..."
  echo "Options:"
  echo "  -f FILES    : remove files with specific file name (req.)"
  echo "  -m TIME[dm] : remove files older than TIME (d - days, m - minutes, req.)"
  echo "  -t          : do not remove, just test"
  exit 1
}

unset FILES TIME TEST DIMENSION

while getopts f:m:t c ; do
  case $c in
    f)	FILES=$OPTARG ;;
    m)	TIME=$OPTARG ;;
    t)	TEST=-t ;;
    *) usage ;;
  esac
done
shift `expr $OPTIND - 1`

[ $# -eq 0 -o -z "$FILES" -o -z "$TIME" ] && usage
expr "$TIME" : ".*d$" >/dev/null 2>&1 && DIMENSION="mtime"
expr "$TIME" : ".*m$" >/dev/null 2>&1 && DIMENSION="mmin"
TIME=`echo $TIME | sed 's/[dm]$//'`
expr "$TIME" : "[0-9][0-9]*$" >/dev/null 2>&1
[ $? -ne 0 -o -z "$DIMENSION" ] && usage

mkdir /tmp/.test.$$ || exit 1
( cd / ; find /tmp/.test.$$ -$DIMENSION 1 >/dev/null 2>&1 )
rmdir /tmp/.test.$$

NAMES=`echo "$FILES" | sed -e 's/^[[:space:]]\+//' -e 's/[[:space:]]\+$//' -e "s/[[:space:]]\+/' -o -name '/" -e "s/^/-name '/" -e "s/$/'/"`

for i in $@ ; do
  [ -d $i ] || continue
  eval "find $i -follow -type f \( $NAMES \) -$DIMENSION +$TIME" | while read file ; do
    [ -n "$TEST" ] && ls -ld "$file"  || rm -f "$file"
  done
done
#
# END
#
